unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  IntfGraphics, LCLType, LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    StartTime : Qword;
    function FindLeft: Integer;
    function FindLeft_Scan: Integer;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

{------------------------------------------------------------------------------}
{ sucht von links an den ersten Pixel ungleich weiss   }
{ liefert 0.. width-1 zurück wenn Pixel gefunden wurde }
{ liefert -1 zurück wenn kein Pixel gefunden wurde     }
function TForm1.FindLeft:Integer;
var x,y:Integer;
begin
  for x:=Paintbox1.Left to Paintbox1.Left+Paintbox1.Width-1 do begin   { horizontal von links nach rechts suchen }
    result:=x-Paintbox1.Left;
    for y:=Paintbox1.Top to Paintbox1.Top+Paintbox1.Height-1 do begin  { vertikal von oben nach unten suchen }
      if canvas.Pixels[x,y]<>clWhite then exit; { Pixel gefunden, dann Ende }
    end;
  end;
  result:=-1;  { result = -1 wenn keinen Pixel gefunden }
end;

function TForm1.FindLeft_Scan:Integer;
var bmp : TBitmap;
    Image1 : TLazIntfImage;
    valR,valG,valB : byte;
    x,y            : integer;
    P              : TPoint;
begin
 Bmp       := TBitmap.Create;
 try
  Bmp.SetSize(Paintbox1.Width,Paintbox1.Height);
  Bmp.Canvas.CopyRect(rect(0,0,Paintbox1.Width,Paintbox1.Height),Paintbox1.Canvas,rect(0,0,Paintbox1.Width,Paintbox1.Height));
  Image1:= Bmp.CreateIntfImage;
  for x:=0 to Paintbox1.Width-1 do begin   { horizontal von links nach rechts suchen }
    result:=x;
    for y:= 0 to Paintbox1.Height-1 do begin  { vertikal von oben nach unten suchen }
      P.X:=x; P.Y:=y;
      valR:= PRGBQUAD(Image1.GetDataLineStart(P.Y))[P.X].rgbRed;
      valG:= PRGBQuad(Image1.GetDataLineStart(P.Y))[P.X].rgbGreen;
      valB:= PRGBQuad(Image1.GetDataLineStart(P.Y))[P.X].rgbBlue;
      if RGB(valR,valG,ValB) <> clWhite then exit;
    end;
  end;
  result:=-1;

 finally
  Image1.Free;
  Bmp.free
 end;


end;



procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 canvas.Brush.Color:= clWhite;
 canvas.FillRect(Paintbox1.Left,Paintbox1.Top,Paintbox1.Left+Paintbox1.Width,Paintbox1.Top+Paintbox1.Height);

 canvas.Brush.Color:= clLime;
 canvas.FillRect(Paintbox1.Left+50,Paintbox1.Top+50,Paintbox1.Left+Paintbox1.Width-50,Paintbox1.Top+Paintbox1.Height-50);
end;

procedure TForm1.Button1Click(Sender: TObject);
var i : integer;
begin
 StartTime := getTickCount64;
 i := FindLeft;
 Label1.Caption:= 'Left Pixel: '+ inttostr(i)+'    Time: '+inttostr(GetTickCount64 - StartTime)+'ms';

end;

procedure TForm1.Button2Click(Sender: TObject);
var i : integer;
begin
 StartTime := getTickCount64;
 i := FindLeft_Scan;
 Label1.Caption:= 'Left Pixel: '+ inttostr(i)+'    Time: '+inttostr(GetTickCount64 - StartTime)+'ms';
end;





end.
